Draft Upgrade/ru: Difference between revisions

From FreeCAD Documentation
(Updating to match new version of source page)
(Updating to match new version of source page)
 
(12 intermediate revisions by 4 users not shown)
Line 1: Line 1:
<languages/>
<languages/>

{{docnav|[[Draft_Split|Split]]|[[Draft_Downgrade|Downgrade]]|[[Draft_Module|Draft_Module]]}}
{{Docnav
|[[Draft_Split|Split]]
|[[Draft_Downgrade|Downgrade]]
|[[Draft_Workbench|Draft]]
|IconL=Draft_Split.svg
|IconR=Draft_Downgrade.svg
|IconC=Workbench_Draft.svg
}}


<div class="mw-translate-fuzzy">
<div class="mw-translate-fuzzy">
Line 6: Line 14:
|Name=Draft Upgrade
|Name=Draft Upgrade
|Name/ru=Draft Upgrade
|Name/ru=Draft Upgrade
|Workbenches=[[Draft Module/ru|Draft]], [[Arch Module/ru|Arch]]
|MenuLocation=Черчение → Обновить
|MenuLocation=Черчение → Обновить
|Workbenches=[[Draft_Workbench/ru|Draft]], [[Arch_Workbench/ru|Arch]]
|Shortcut=U P
|Shortcut={{KEY|U}} {{KEY|P}}
|SeeAlso=[[Draft Downgrade/ru|Перестроить]]
|SeeAlso=[[Draft_Downgrade/ru|Draft Downgrade]], [[Part_Fuse/ru|Part Fuse]]
}}
}}
</div>
</div>


<span id="Description"></span>
==Описание==
==Описание==


Line 18: Line 27:
Этот инструмент изменяет выбранные объекты по-разному. Если ни один объект не выбран, вам будет предложено выбрать его.
Этот инструмент изменяет выбранные объекты по-разному. Если ни один объект не выбран, вам будет предложено выбрать его.
</div>
</div>

The Upgrade tool performs things such as creating faces and fusing different elements. This tool works with 2D Draft elements. To fuse 3D solids use [[Part Union]] and related Boolean operations of the [[Part Workbench]], and [[PartDesign Boolean]] of the [[PartDesign Workbench]].

The counterpart to this tool is the [[Draft Downgrade]] operation.


[[Image:Draft_Upgrade_example.jpg|400px]]
[[Image:Draft_Upgrade_example.jpg|400px]]
{{Caption|Open wire upgraded to a closed wire, then to a face; a closed square upgraded to a face, and then fused with the previous face}}
{{Caption|An open non-editable wire is upgraded to a closed wire, and then to a face. A closed non-editable square wire is also upgraded to a face. The two faces are then upgraded to create a compound, which is finally upgraded to a single editable Draft Wire.}}


<span id="Usage"></span>
==Использование==
==Использование==


Line 33: Line 39:
</div>
</div>


==Notes==
The selected objects are modified or upgraded according to the following conditions, in order:
# If there are more than one face in the selection, the faces are merged (union).
# If there is only one face in the selection, nothing is done.
# If there is only one open wire in the selection, it gets closed, making a face.
# If there are only edges in the selection, all edges are joined into a wire, and the wire is closed if possible.
# If none of the above is possible, a compound object is created.


* [[Draft_Line|Draft Lines]] and [[Draft_Wire|Draft Wires]] can be joined with this command, but also with the [[Draft_Join|Draft Join]] command or the [[Draft_Wire|Draft Wire]] command.
It is worth trying to upgrade a selection several times to see if a better shape is obtained. For example:
# Upgrading two [[Draft Line]]s connected at one end will result in a non-editable wire.
# Upgrading this element again will add a third line and close the non-editable wire.
# Upgrading this element again will add a face to the closed, non-editable wire.
# Upgrading this element again will turn it into a [[Draft Wire]], which can be fully edited, and all its properties modified.


==Scripting==
The resulting wire can be better manipulated than the original lines. The fusion of single lines can also be done directly with the [[Draft Wire]] tool. Some fusion operations can also be done with the [[Part Union|Part Union]] tool.

==Опции==

<div class="mw-translate-fuzzy">
Выбранные объекты модифицируются / обновляются в соответствии со следующими условиями (в порядке):
* если в выборе выделено более одного грань , грани объединяются (объединяются)ь
* if there is only one face in the selection, nothing is done
* if there is only one open wire in the selection, it gets closed
* if there are only edges in the selection, all edges are joined into a wire (closed if possible)
* если ни одно из указанных выше не возможно, создается составной объект
</div>


<div class="mw-translate-fuzzy">
<div class="mw-translate-fuzzy">
Line 64: Line 50:


<div class="mw-translate-fuzzy">
<div class="mw-translate-fuzzy">
Инструмент Апгрейд можно использовать из скриптов python и [[макросов]] следующим образом:
Инструмент Апгрейд можно использовать из скриптов python и [[Macros|макросов]] следующим образом:
</div>
</div>


{{Code|code=
{{Code|code=
upgrade_list = upgrade(objects, delete=False, force=None)
upgrade_list = upgrade(objects, delete=False, force=None)
addList, deleteList = upgrade(objects, delete=False, force=None)
}}
}}


* Upgrades the given {{incode|objects}}, which can be a single object or a list of objects.
* {{incode|objects}} contains the objects to be upgraded. It is either a single object or a list of objects.
* If {{incode|delete}} is {{incode|True}}, old objects are deleted.
* If {{incode|delete}} is {{incode|True}} the source objects are deleted.
* If {{incode|force}} is given, it is the internal function to call to force a certain way of upgrading. It can be: {{incode|"makeCompound"}}, {{incode|"closeGroupWires"}}, {{incode|"makeSolid"}}, {{incode|"closeWire"}}, {{incode|"turnToParts"}}, {{incode|"makeFusion"}}, {{incode|"makeShell"}}, {{incode|"makeFaces"}}, {{incode|"draftify"}}, {{incode|"joinFaces"}}, {{incode|"makeSketchFace"}}, {{incode|"makeWires"}}, or {{incode|"turnToLine"}}.
* {{incode|force}} forces a certain way of upgrading by calling a specific internal function. It can be: {{incode|"makeCompound"}}, {{incode|"closeGroupWires"}}, {{incode|"makeSolid"}}, {{incode|"closeWire"}}, {{incode|"turnToParts"}}, {{incode|"makeFusion"}}, {{incode|"makeShell"}}, {{incode|"makeFaces"}}, {{incode|"draftify"}}, {{incode|"joinFaces"}}, {{incode|"makeSketchFace"}}, {{incode|"makeWires"}} or {{incode|"turnToLine"}}.
* {{incode|upgrade_list}} is returned, which is a list containing two lists: a list of new objects ({{incode|addList}}) and a list of objects to be deleted ({{incode|deleteList}}).
* {{incode|upgrade_list}} is returned. It is a list containing two lists: a list of new objects and a list of objects to be deleted. If {{incode|delete}} is {{incode|True}} the second list is empty.


Пример:
Пример:


{{Code|code=
{{Code|code=
import FreeCAD, Draft
import FreeCAD as App
import Draft


doc = App.newDocument()
Circle = Draft.makeCircle(1000)
Rectangle = Draft.makeRectangle(2000, 800)


circle = Draft.make_circle(1000)
addList1, deleteList1 = Draft.upgrade([Circle, Rectangle], delete=False)
rectangle = Draft.make_rectangle(2000, 800)
fused = addList1[0]
doc.recompute()


add_list1, delete_list1 = Draft.upgrade([circle, rectangle], delete=False)
Line1 = Draft.makeLine(FreeCAD.Vector(2000, 0, 0), FreeCAD.Vector(2500, 1500, 0))
Line2 = Draft.makeLine(FreeCAD.Vector(2500, 1500, 0), FreeCAD.Vector(3000, -1000, 0))
addList2, deleteList2 = Draft.upgrade([Line1, Line2], delete=False)


line1 = Draft.make_line(App.Vector(2000, 0, 0), App.Vector(2500, 1500, 0))
simple_wire = addList2[0]
line2 = Draft.make_line(App.Vector(2500, 1500, 0), App.Vector(3000, -1000, 0))
addList3, deleteList3 = Draft.upgrade(simple_wire, delete=False)
doc.recompute()

add_list2, delete_list2 = Draft.upgrade([line1, line2], delete=False)

simple_wire = add_list2[0]
add_list3, delete_list3 = Draft.upgrade(simple_wire, delete=False)

closed_wire = add_list3[0]
add_list4, delete_list4 = Draft.upgrade(closed_wire, delete=False)

face = add_list4[0]
add_list5, delete_list5 = Draft.upgrade(face, delete=False)

doc.recompute()
}}


closed_wire = addList3[0]
addList4, deleteList4 = Draft.upgrade(closed_wire, delete=False)


{{Docnav
face = addList4[0]
|[[Draft_Split|Split]]
addList5, deleteList5 = Draft.upgrade(face, delete=False)
|[[Draft_Downgrade|Downgrade]]
|[[Draft_Workbench|Draft]]
|IconL=Draft_Split.svg
|IconR=Draft_Downgrade.svg
|IconC=Workbench_Draft.svg
}}
}}


{{Draft Tools navi{{#translation:}}}}
{{docnav|[[Draft_Split|Split]]|[[Draft_Downgrade|Downgrade]]|[[Draft_Module|Draft_Module]]}}
{{Userdocnavi{{#translation:}}}}
{{Draft Tools navi}}
{{Userdocnavi}}
{{clear}}

Latest revision as of 19:53, 7 December 2023

Draft Upgrade

Системное название
Draft Upgrade
Расположение в меню
Черчение → Обновить
Верстаки
Draft, Arch
Быстрые клавиши
U P
Представлено в версии
-
См. также
Draft Downgrade, Part Fuse

Описание

Этот инструмент изменяет выбранные объекты по-разному. Если ни один объект не выбран, вам будет предложено выбрать его.

An open non-editable wire is upgraded to a closed wire, and then to a face. A closed non-editable square wire is also upgraded to a face. The two faces are then upgraded to create a compound, which is finally upgraded to a single editable Draft Wire.

Использование

  1. Выберите один или несколько объектов, которые вы хотите обновить.
  2. Нажмите кнопку Draft Upgrade или нажмите U, затем P

Notes

Scripting

Скриптование

Инструмент Апгрейд можно использовать из скриптов python и макросов следующим образом:

upgrade_list = upgrade(objects, delete=False, force=None)
  • objects contains the objects to be upgraded. It is either a single object or a list of objects.
  • If delete is True the source objects are deleted.
  • force forces a certain way of upgrading by calling a specific internal function. It can be: "makeCompound", "closeGroupWires", "makeSolid", "closeWire", "turnToParts", "makeFusion", "makeShell", "makeFaces", "draftify", "joinFaces", "makeSketchFace", "makeWires" or "turnToLine".
  • upgrade_list is returned. It is a list containing two lists: a list of new objects and a list of objects to be deleted. If delete is True the second list is empty.

Пример:

import FreeCAD as App
import Draft

doc = App.newDocument()

circle = Draft.make_circle(1000)
rectangle = Draft.make_rectangle(2000, 800)
doc.recompute()

add_list1, delete_list1 = Draft.upgrade([circle, rectangle], delete=False)

line1 = Draft.make_line(App.Vector(2000, 0, 0), App.Vector(2500, 1500, 0))
line2 = Draft.make_line(App.Vector(2500, 1500, 0), App.Vector(3000, -1000, 0))
doc.recompute()

add_list2, delete_list2 = Draft.upgrade([line1, line2], delete=False)

simple_wire = add_list2[0]
add_list3, delete_list3 = Draft.upgrade(simple_wire, delete=False)

closed_wire = add_list3[0]
add_list4, delete_list4 = Draft.upgrade(closed_wire, delete=False)

face = add_list4[0]
add_list5, delete_list5 = Draft.upgrade(face, delete=False)

doc.recompute()